/*
Redner Odoo module
Copyright (C) 2016 XCG Consulting <https://xcg-consulting.fr>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

odoo.define("redner.report", function (require) {
    "use strict";

    var ActionManager = require("web.ActionManager");

    ActionManager.include({
        _executeReportAction: function (action, options) {
            // Redner reports
            if (action.report_type === "redner") {
                console.log(action.report_type);
                return this._triggerDownload(action, options, "redner");
            }
            return this._super.apply(this, arguments);
        },
        _makeReportUrls: function (action) {
            var reportUrls = this._super.apply(this, arguments);
            reportUrls.redner = "/report/redner/" + action.report_name;
            // We may have to build a query string with `action.data`. It's the place
            // were report's using a wizard to customize the output traditionally put
            // their options.
            if (
                _.isUndefined(action.data) ||
                _.isNull(action.data) ||
                (_.isObject(action.data) && _.isEmpty(action.data))
            ) {
                if (action.context.active_ids) {
                    var activeIDsPath = "/" + action.context.active_ids.join(",");
                    reportUrls.redner += activeIDsPath;
                }
            } else {
                var serializedOptionsPath =
                    "?options=" + encodeURIComponent(JSON.stringify(action.data));
                serializedOptionsPath +=
                    "&context=" + encodeURIComponent(JSON.stringify(action.context));
                reportUrls.redner += serializedOptionsPath;
            }
            return reportUrls;
        },
    });
});
